# - Find HEALPIX    
# Find the native HEALPIX includes and library 
#
# HEALPIX_INCLUDES - where to find fftw3.h
# HEALPIX_LIBRARIES - List of libraries when using HEALPIX.
# HEALPIX_FOUND - True if HEALPIX found.
if (HEALPIX_INCLUDES)
# Already in cache, be silent 
set (HEALPIX_FIND_QUIETLY TRUE)
endif (HEALPIX_INCLUDES)
find_path (HEALPIX_INCLUDES healpix_base.h HINTS ENV HEALPIX_INCLUDE_DIR)

find_library (HEALPIX_CXX_LIBRARIES NAMES healpix_cxx HINTS ENV HEALPIX_LIB_DIR)
find_library (HEALPIX_CXX_SUPPORT_LIBRARIES NAMES cxxsupport HINTS ENV HEALPIX_LIB_DIR)
find_library (HEALPIX_SHARP_LIBRARIES NAMES sharp HINTS ENV HEALPIX_LIB_DIR)
find_library (HEALPIX_FFTPACK_LIBRARIES NAMES fftpack HINTS ENV HEALPIX_LIB_DIR)
find_library (HEALPIX_UTILS_LIBRARIES NAMES c_utils HINTS ENV HEALPIX_LIB_DIR)

set(HEALPIX_LIBRARIES ${HEALPIX_CXX_LIBRARIES} ${HEALPIX_CXX_SUPPORT_LIBRARIES} ${HEALPIX_SHARP_LIBRARIES} ${HEALPIX_FFTPACK_LIBRARIES} ${HEALPIX_UTILS_LIBRARIES})

# handle the QUIETLY and REQUIRED arguments and set HEALPIX_FOUND to TRUE if
# all listed variables are TRUE 
include (FindPackageHandleStandardArgs)
find_package_handle_standard_args (HEALPIX DEFAULT_MSG HEALPIX_LIBRARIES HEALPIX_INCLUDES)
mark_as_advanced (HEALPIX_LIBRARIES HEALPIX_INCLUDES)


